Bug 1464350 - [RFE] Posix xlator needs to reserve disk space to prevent the brick from getting full. [NEEDINFO]
Summary: [RFE] Posix xlator needs to reserve disk space to prevent the brick from gett...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: posix
Version: rhgs-3.3
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
: RHGS 3.4.0
Assignee: Mohit Agrawal
QA Contact: Prasad Desala
URL:
Whiteboard:
Depends On:
Blocks: 1173519 1286092 1398595 1471366 1476158 1503132
TreeView+ depends on / blocked
 
Reported: 2017-06-23 07:48 UTC by Nithya Balachandran
Modified: 2018-09-06 09:27 UTC (History)
7 users (show)

Fixed In Version: glusterfs-3.12.2-2
Doc Type: Enhancement
Doc Text:
The POSIX translator is now enhanced with an option that allows user to reserve disk space on the bricks. Some administrative operations, like expanding storage or rebalancing data across nodes, require spare working space on the disk. The storage.reserve option lets users expand disk or cluster when backend bricks are full preventing ENOSPC errors on mount points.
Clone Of:
: 1471366 1476158 (view as bug list)
Environment:
Last Closed: 2018-09-04 06:32:36 UTC
srmukher: needinfo? (moagrawa)


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2018:2607 None None None 2018-09-04 06:34:40 UTC
Red Hat Bugzilla 1531933 None CLOSED [Doc RFE] Doument the storage.reserve option 2019-05-28 10:58:45 UTC

Internal Links: 1531933

Description Nithya Balachandran 2017-06-23 07:48:41 UTC
Description of problem:

Once a brick becomes completely (100%) full, the gluster filesystem becomes inconsistent as xattr operations fail and recovery is very difficult.

A rebalance cannot be used to migrate data off the full brick as xattr operations will fail.

DHT uses a min-free-disk option to try to keep some reserve space on all bricks. However, this approach is not fool proof and should ideally be handled by the posix xlator. 

Version-Release number of selected component (if applicable):


How reproducible:


Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:

Comment 3 Mohit Agrawal 2017-07-17 01:57:36 UTC
Patch is posted on upstream 

https://review.gluster.org/#/c/17780/

Comment 7 Prasad Desala 2018-03-12 13:58:21 UTC
Verified this RFE on glusterfs version: 3.12.2-5.el7rhgs.x86_64

1) Able to set/reset storage.reserve volume set option.
2) Reserved the space to 50% and created files using dd created files. Once the backend bricks reached the reserved space, file creation is failing with ENOSPC errors.

I have filed below BZs while testing this RFE,
https://bugzilla.redhat.com/show_bug.cgi?id=1554291
https://bugzilla.redhat.com/show_bug.cgi?id=1550991
https://bugzilla.redhat.com/show_bug.cgi?id=1550982
https://bugzilla.redhat.com/show_bug.cgi?id=1554298

Moving this BZ to Verified considering the basic functional is working and have bugs filed for the seen issues. Will file new BZs on this feature if seen during our regression testing.

Comment 9 errata-xmlrpc 2018-09-04 06:32:36 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2018:2607


Note You need to log in before you can comment on or make changes to this bug.